class AcidSynthLSTM(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  ac : __torch__.audio_config.AudioConfig
  n_hidden : int
  n_ch : int
  vco : __torch__.acid_ddsp.synth_modules.SquareSawVCOLite
  env_gen : __torch__.acid_ddsp.synth_modules.ExpDecayEnv
  lstm : __torch__.torch.nn.modules.rnn.LSTM
  out_lstm : __torch__.torch.nn.modules.linear.Linear
  def forward(self: __torch__.synths.AcidSynthLSTM,
    n_samples: int,
    f0_hz: Tensor,
    note_on_duration: Tensor,
    phase: Tensor,
    filter_args: Dict[str, Tensor],
    global_params: Dict[str, Tensor],
    envelope: Optional[Tensor]=None) -> Dict[str, Tensor]:
    osc_shape = torch.get(global_params, "osc_shape")
    if torch.__is__(osc_shape, None):
      ac = self.ac
      if (ac).is_fixed("osc_shape", ):
        pass
      else:
        ops.prim.RaiseException("AssertionError: ")
      ac0 = self.ac
      min_osc_shape = ac0.min_osc_shape
      osc_shape1 = torch.full_like(f0_hz, min_osc_shape)
      osc_shape0 = osc_shape1
    else:
      osc_shape0 = unchecked_cast(Tensor, osc_shape)
    osc_gain = torch.get(global_params, "osc_gain")
    if torch.__is__(osc_gain, None):
      ac1 = self.ac
      if (ac1).is_fixed("osc_gain", ):
        pass
      else:
        ops.prim.RaiseException("AssertionError: ")
      ac2 = self.ac
      min_osc_gain = ac2.min_osc_gain
      osc_gain1 = torch.full_like(f0_hz, min_osc_gain)
      osc_gain0 = osc_gain1
    else:
      osc_gain0 = unchecked_cast(Tensor, osc_gain)
    dist_gain = torch.get(global_params, "dist_gain")
    if torch.__is__(dist_gain, None):
      ac3 = self.ac
      if (ac3).is_fixed("dist_gain", ):
        pass
      else:
        ops.prim.RaiseException("AssertionError: ")
      ac4 = self.ac
      min_dist_gain = ac4.min_dist_gain
      dist_gain1 = torch.full_like(f0_hz, min_dist_gain)
      dist_gain0 = dist_gain1
    else:
      dist_gain0 = unchecked_cast(Tensor, dist_gain)
    learned_alpha = torch.get(global_params, "learned_alpha")
    if torch.__is__(learned_alpha, None):
      ac5 = self.ac
      if (ac5).is_fixed("learned_alpha", ):
        pass
      else:
        ops.prim.RaiseException("AssertionError: ")
      ac6 = self.ac
      min_learned_alpha = ac6.min_learned_alpha
      learned_alpha1 = torch.full_like(f0_hz, min_learned_alpha)
      learned_alpha0 = learned_alpha1
    else:
      learned_alpha2 = unchecked_cast(Tensor, learned_alpha)
      learned_alpha0 = learned_alpha2
    _0 = torch.eq(torch.size(note_on_duration), torch.size(osc_shape0))
    if _0:
      _2 = torch.eq(torch.size(osc_shape0), torch.size(osc_gain0))
      _1 = _2
    else:
      _1 = False
    if _1:
      _4 = torch.eq(torch.size(osc_gain0), torch.size(dist_gain0))
      _3 = _4
    else:
      _3 = False
    if _3:
      _6 = torch.eq(torch.size(dist_gain0), torch.size(learned_alpha0))
      _5 = _6
    else:
      _5 = False
    if _5:
      pass
    else:
      ops.prim.RaiseException("AssertionError: ")
    vco = self.vco
    dry_audio = (vco).forward(f0_hz, osc_shape0, n_samples, phase, )
    dry_audio0 = torch.mul_(dry_audio, torch.unsqueeze(osc_gain0, -1))
    if torch.__is__(envelope, None):
      env_gen = self.env_gen
      envelope1 = (env_gen).forward(learned_alpha0, note_on_duration, n_samples, )
      envelope0 = envelope1
    else:
      envelope0 = unchecked_cast(Tensor, envelope)
    dry_audio1 = torch.mul_(dry_audio0, envelope0)
    _7 = (self).filter_dry_audio(dry_audio1, filter_args, )
    filtered_audio, filter_out, = _7
    wet_audio = torch.mul(filtered_audio, torch.unsqueeze(dist_gain0, -1))
    wet_audio0 = torch.tanh(wet_audio)
    synth_out = {"dry": dry_audio1, "wet": wet_audio0, "envelope": envelope0, "filtered_audio": filtered_audio}
    torch.update(synth_out, filter_out)
    return synth_out
  def filter_dry_audio(self: __torch__.synths.AcidSynthLSTM,
    x: Tensor,
    filter_args: Dict[str, Tensor]) -> Tuple[Tensor, Dict[str, Tensor]]:
    w_mod_sig = filter_args["w_mod_sig"]
    q_mod_sig = filter_args["q_mod_sig"]
    if torch.eq(torch.dim(w_mod_sig), 3):
      w_mod_sig0 = torch.squeeze(w_mod_sig, 2)
    else:
      w_mod_sig0 = w_mod_sig
    if torch.eq(torch.dim(q_mod_sig), 3):
      q_mod_sig0 = torch.squeeze(q_mod_sig, 2)
    else:
      q_mod_sig0 = q_mod_sig
    _8 = (self).resize_mod_sig(x, w_mod_sig0, q_mod_sig0, )
    w_mod_sig1, q_mod_sig1, = _8
    h_n = torch.get(filter_args, "h_n")
    c_n = torch.get(filter_args, "c_n")
    if torch.__isnot__(h_n, None):
      h_n1 = unchecked_cast(Tensor, h_n)
      _9, h_n0 = torch.__isnot__(c_n, None), h_n1
    else:
      _9, h_n0 = False, h_n
    if _9:
      h_n2 = unchecked_cast(Tensor, h_n0)
      c_n0 = unchecked_cast(Tensor, c_n)
      _10 = torch.size(h_n2)
      n_hidden = self.n_hidden
      if torch.eq(_10, [1, 1, n_hidden]):
        _11 = torch.size(c_n0)
        n_hidden0 = self.n_hidden
        _12 = torch.eq(_11, [1, 1, n_hidden0])
        if _12:
          hidden1 : Optional[Tuple[Tensor, Tensor]] = (h_n2, c_n0)
        else:
          hidden1 = None
        hidden0 : Optional[Tuple[Tensor, Tensor]] = hidden1
      else:
        hidden0 = None
      hidden : Optional[Tuple[Tensor, Tensor]] = hidden0
    else:
      hidden = None
    x0 = torch.stack([x, w_mod_sig1, q_mod_sig1], 2)
    lstm = self.lstm
    x1, _13, = (lstm).forward__0(x0, hidden, )
    new_h_n, new_c_n, = _13
    out_lstm = self.out_lstm
    x2 = (out_lstm).forward(x1, )
    x3 = torch.squeeze(x2, -1)
    x4 = torch.add(x3, x)
    x5 = torch.tanh(x4)
    filter_out = {"h_n": new_h_n, "c_n": new_c_n}
    return (x5, filter_out)
  def resize_mod_sig(self: __torch__.synths.AcidSynthLSTM,
    x: Tensor,
    w_mod_sig: Tensor,
    q_mod_sig: Tensor) -> Tuple[Tensor, Tensor]:
    _14 = __torch__.util.linear_interpolate_dim
    _15 = torch.eq(torch.dim(w_mod_sig), torch.dim(q_mod_sig))
    if _15:
      _17 = torch.eq(torch.dim(q_mod_sig), torch.dim(x))
      _16 = _17
    else:
      _16 = False
    if _16:
      _18 = torch.eq(torch.dim(x), 2)
    else:
      _18 = False
    if _18:
      pass
    else:
      ops.prim.RaiseException("AssertionError: ")
    w_mod_sig2 = _14(w_mod_sig, torch.size(x, 1), -1, True, )
    q_mod_sig2 = _14(q_mod_sig, torch.size(x, 1), -1, True, )
    return (w_mod_sig2, q_mod_sig2)
