class LSTM(Module):
  __parameters__ = ["weight_ih_l0", "weight_hh_l0", "bias_ih_l0", "bias_hh_l0", ]
  __buffers__ = []
  weight_ih_l0 : Tensor
  weight_hh_l0 : Tensor
  bias_ih_l0 : Tensor
  bias_hh_l0 : Tensor
  training : bool
  _is_full_backward_hook : NoneType
  _flat_weights_names : List[str]
  _all_weights : List[List[str]]
  _flat_weights : List[Tensor]
  input_size : Final[int] = 3
  proj_size : Final[int] = 0
  hidden_size : Final[int] = 64
  batch_first : Final[bool] = True
  bidirectional : Final[bool] = False
  mode : Final[str] = "LSTM"
  dropout : Final[float] = 0.
  num_layers : Final[int] = 1
  bias : Final[bool] = True
  def forward__0(self: __torch__.torch.nn.modules.rnn.LSTM,
    input: Tensor,
    hx: Optional[Tuple[Tensor, Tensor]]=None) -> Tuple[Tensor, Tuple[Tensor, Tensor]]:
    _0 = "LSTM: Expected input to be 2D or 3D, got {}D instead"
    _1 = "For batched 3-D input, hx and cx should also be 3-D but got ({}-D, {}-D) tensors"
    _2 = "For unbatched 2-D input, hx and cx should also be 2-D but got ({}-D, {}-D) tensors"
    _3 = (self)._update_flat_weights()
    _4 = torch.dim(input)
    _5 = torch.__not__(torch.__contains__([2, 3], _4))
    if _5:
      _6 = torch.format(_0, torch.dim(input))
      ops.prim.RaiseException(_6, "builtins.ValueError")
    else:
      pass
    is_batched = torch.eq(torch.dim(input), 3)
    if torch.__not__(is_batched):
      input0 = torch.unsqueeze(input, 0)
    else:
      input0 = input
    max_batch_size = torch.size(input0, 0)
    if torch.__is__(hx, None):
      _7 = ops.prim.dtype(input0)
      _8 = ops.prim.device(input0)
      h_zeros = torch.zeros([1, max_batch_size, 64], dtype=_7, layout=None, device=_8)
      _9 = ops.prim.dtype(input0)
      _10 = ops.prim.device(input0)
      c_zeros = torch.zeros([1, max_batch_size, 64], dtype=_9, layout=None, device=_10)
      hx0 = (h_zeros, c_zeros)
    else:
      hx1 = unchecked_cast(Tuple[Tensor, Tensor], hx)
      if is_batched:
        _11 = torch.ne(torch.dim((hx1)[0]), 3)
        if _11:
          _12 = True
        else:
          _13 = torch.ne(torch.dim((hx1)[1]), 3)
          _12 = _13
        if _12:
          msg = torch.format(_1, torch.dim((hx1)[0]), torch.dim((hx1)[1]))
          ops.prim.RaiseException(msg, "builtins.RuntimeError")
        else:
          pass
        hx2 = hx1
      else:
        _14 = torch.ne(torch.dim((hx1)[0]), 2)
        if _14:
          _15 = True
        else:
          _16 = torch.ne(torch.dim((hx1)[1]), 2)
          _15 = _16
        if _15:
          msg0 = torch.format(_2, torch.dim((hx1)[0]), torch.dim((hx1)[1]))
          ops.prim.RaiseException(msg0, "builtins.RuntimeError")
        else:
          pass
        hx3 = (torch.unsqueeze((hx1)[0], 1), torch.unsqueeze((hx1)[1], 1))
        hx2 = hx3
      _17 = (self).check_forward_args(input0, hx2, None, )
      hx4 = (self).permute_hidden(hx2, None, )
      hx0 = hx4
    _flat_weights = self._flat_weights
    training = self.training
    _18, _19, = hx0
    _20, _21, _22 = torch.lstm(input0, [_18, _19], _flat_weights, True, 1, 0., training, False, True)
    hidden = (_21, _22)
    if torch.__not__(is_batched):
      output0 = torch.squeeze(_20, 0)
      hidden1 = (torch.squeeze(_21, 1), torch.squeeze(_22, 1))
      hidden0, output = hidden1, output0
    else:
      hidden0, output = hidden, _20
    _23 = (self).permute_hidden(hidden0, None, )
    return (output, _23)
  def forward__1(self: __torch__.torch.nn.modules.rnn.LSTM,
    input: __torch__.torch.nn.utils.rnn.PackedSequence,
    hx: Optional[Tuple[Tensor, Tensor]]=None) -> Tuple[__torch__.torch.nn.utils.rnn.PackedSequence, Tuple[Tensor, Tensor]]:
    _24 = (self)._update_flat_weights()
    input1, batch_sizes, sorted_indices, unsorted_indices, = input
    max_batch_size = torch.select(batch_sizes, 0, 0)
    if torch.__is__(hx, None):
      _25 = ops.prim.dtype(input1)
      _26 = ops.prim.device(input1)
      _27 = [1, annotate(int, max_batch_size), 64]
      h_zeros = torch.zeros(_27, dtype=_25, layout=None, device=_26)
      _28 = ops.prim.dtype(input1)
      _29 = ops.prim.device(input1)
      _30 = [1, annotate(int, max_batch_size), 64]
      c_zeros = torch.zeros(_30, dtype=_28, layout=None, device=_29)
      hx5 = (h_zeros, c_zeros)
    else:
      hx6 = unchecked_cast(Tuple[Tensor, Tensor], hx)
      hx7 = (self).permute_hidden(hx6, sorted_indices, )
      hx5 = hx7
    _flat_weights = self._flat_weights
    training = self.training
    _31, _32, = hx5
    _33, _34, _35 = torch.lstm(input1, batch_sizes, [_31, _32], _flat_weights, True, 1, 0., training, False)
    hidden = (_34, _35)
    output_packed = __torch__.torch.nn.utils.rnn.PackedSequence(_33, batch_sizes, sorted_indices, unsorted_indices)
    _36 = (self).permute_hidden(hidden, unsorted_indices, )
    return (output_packed, _36)
  def _update_flat_weights(self: __torch__.torch.nn.modules.rnn.LSTM) -> NoneType:
    return None
  def check_forward_args(self: __torch__.torch.nn.modules.rnn.LSTM,
    input: Tensor,
    hidden: Tuple[Tensor, Tensor],
    batch_sizes: Optional[Tensor]) -> NoneType:
    _37 = "Expected hidden[0] size {}, got {}"
    _38 = "Expected hidden[1] size {}, got {}"
    _39 = (self).check_input(input, batch_sizes, )
    _40 = (hidden)[0]
    _41 = (self).get_expected_hidden_size(input, batch_sizes, )
    _42 = (self).check_hidden_size(_40, _41, _37, )
    _43 = (hidden)[1]
    _44 = (self).get_expected_cell_size(input, batch_sizes, )
    _45 = (self).check_hidden_size(_43, _44, _38, )
    return None
  def check_input(self: __torch__.torch.nn.modules.rnn.LSTM,
    input: Tensor,
    batch_sizes: Optional[Tensor]) -> NoneType:
    _46 = "input must have {} dimensions, got {}"
    _47 = "input.size(-1) must be equal to input_size. Expected {}, got {}"
    if torch.__isnot__(batch_sizes, None):
      expected_input_dim = 2
    else:
      expected_input_dim = 3
    _48 = torch.ne(torch.dim(input), expected_input_dim)
    if _48:
      _49 = torch.format(_46, expected_input_dim, torch.dim(input))
      ops.prim.RaiseException(_49, "builtins.RuntimeError")
    else:
      pass
    if torch.ne(3, torch.size(input, -1)):
      _50 = torch.format(_47, 3, torch.size(input, -1))
      ops.prim.RaiseException(_50, "builtins.RuntimeError")
    else:
      pass
    return None
  def check_hidden_size(self: __torch__.torch.nn.modules.rnn.LSTM,
    hx: Tensor,
    expected_hidden_size: Tuple[int, int, int],
    msg: str="Expected hidden size {}, got {}") -> NoneType:
    _51 = torch.size(hx)
    _52, _53, _54, = expected_hidden_size
    if torch.ne(_51, [_52, _53, _54]):
      _55 = torch.format(msg, expected_hidden_size, torch.list(torch.size(hx)))
      ops.prim.RaiseException(_55, "builtins.RuntimeError")
    else:
      pass
    return None
  def get_expected_hidden_size(self: __torch__.torch.nn.modules.rnn.LSTM,
    input: Tensor,
    batch_sizes: Optional[Tensor]) -> Tuple[int, int, int]:
    if torch.__isnot__(batch_sizes, None):
      batch_sizes0 = unchecked_cast(Tensor, batch_sizes)
      mini_batch0 = int(torch.select(batch_sizes0, 0, 0))
      mini_batch = mini_batch0
    else:
      mini_batch = torch.size(input, 0)
    return (1, mini_batch, 64)
  def get_expected_cell_size(self: __torch__.torch.nn.modules.rnn.LSTM,
    input: Tensor,
    batch_sizes: Optional[Tensor]) -> Tuple[int, int, int]:
    if torch.__isnot__(batch_sizes, None):
      batch_sizes1 = unchecked_cast(Tensor, batch_sizes)
      mini_batch1 = int(torch.select(batch_sizes1, 0, 0))
      mini_batch = mini_batch1
    else:
      mini_batch = torch.size(input, 0)
    return (1, mini_batch, 64)
  def permute_hidden(self: __torch__.torch.nn.modules.rnn.LSTM,
    hx: Tuple[Tensor, Tensor],
    permutation: Optional[Tensor]) -> Tuple[Tensor, Tensor]:
    _56 = __torch__.torch.nn.modules.rnn._apply_permutation
    if torch.__is__(permutation, None):
      _57 = hx
    else:
      permutation0 = unchecked_cast(Tensor, permutation)
      _58 = (_56((hx)[0], permutation0, 1, ), _56((hx)[1], permutation0, 1, ))
      _57 = _58
    return _57
def _apply_permutation(tensor: Tensor,
    permutation: Tensor,
    dim: int=1) -> Tensor:
  _59 = torch.index_select(tensor, dim, permutation)
  return _59
